package  
{
	import net.flashpunk.FP;
	import net.flashpunk.graphics.Graphiclist;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.graphics.Stamp;
	import net.flashpunk.graphics.Text;
	import net.flashpunk.World;
	import ui.Button;
	import ui.Checkbox;
	import ui.RadioButton;
	import ui.RadioButtonGroup;
	import ui.TextInput;
	
	public class PetCreator extends World 
	{
		private var nameInput:TextInput;
		
		private var fishRad:RadioButton;
		private var octopusRad:RadioButton;
		private var snakeRad:RadioButton;
		
		private var hatCheck:Checkbox;
		private var wingsCheck:Checkbox;
		private var laserCheck:Checkbox;
		private var friendCheck:Checkbox;
		
		[Embed(source = "../assets/gfx/fish.png")] public static const FISH:Class;
		[Embed(source = "../assets/gfx/friend.png")] public static const FRIEND:Class;
		[Embed(source = "../assets/gfx/hat.png")] public static const HAT:Class;
		[Embed(source = "../assets/gfx/laser.png")] public static const LASER:Class;
		[Embed(source = "../assets/gfx/octopus.png")] public static const OCTOPUS:Class;
		[Embed(source = "../assets/gfx/snake.png")] public static const SNAKE:Class;
		[Embed(source = "../assets/gfx/wing.png")] public static const WING:Class;
		
		private var fish:Stamp;
		private var octopus:Stamp;
		private var snake:Stamp;
		
		private var friend:Stamp;
		private var hat:Stamp;
		private var laser:Stamp;
		private var wing:Stamp;
		
		public function PetCreator() 
		{
			addGraphic(new Text("Pet Creator", 10, 10, { size: 32, color: 0xFFFFFF } ));
			
			//=============
			
			fish = new Stamp(FISH, 250, 20);
			octopus = new Stamp(OCTOPUS, 250, 20);
			snake = new Stamp(SNAKE, 250, 20);
			
			friend = new Stamp(FRIEND, 250, 20);
			hat = new Stamp(HAT, 250, 20);
			laser = new Stamp(LASER, 250, 20);
			wing = new Stamp(WING, 250, 20);
			
			octopus.visible = snake.visible = false;
			friend.visible = hat.visible = laser.visible = wing.visible = false;
			
			addGraphic(new Graphiclist(fish, octopus, snake, friend, hat, laser, wing));
			
			//===============
			
			addGraphic(new Text("Name:", 10, 80, { size: 16, color: 0x8CD5FB } ));
			add(nameInput = new TextInput(80, 80, "Pikachu"));
			
			addGraphic(new Text("Type:", 10, 120, { size: 16, color: 0x8CD5FB } ));
			
			var typeGroup:RadioButtonGroup = new RadioButtonGroup(onType);
			add(fishRad = new RadioButton(10, 150, typeGroup, "Fish", fish, true));
			add(octopusRad = new RadioButton(100, 150, typeGroup, "Octopus", octopus));
			add(snakeRad = new RadioButton(10, 200, typeGroup, "Snake", snake));
			
			addGraphic(new Text("Features:", 10, 270, { size: 16, color: 0x8CD5FB } ));
			add(hatCheck = new Checkbox(10, 300, "Hat", onFeature, hat));
			add(wingsCheck = new Checkbox(120, 300, "Wings", onFeature, wing));
			add(laserCheck = new Checkbox(10, 340, "Laser", onFeature, laser));
			add(friendCheck = new Checkbox(120, 340, "Friend", onFeature, friend));
			
			add(new Button(320, 290, "Random", onRandom));
		}
		
		private function onType(params:Object):void
		{
			fish.visible = octopus.visible = snake.visible = false;
			params.visible = true;
		}
		
		private function onFeature(on:Boolean, params:Object):void
		{
			params.visible = on;
		}
		
		private function onRandom():void
		{
			fish.visible = octopus.visible = snake.visible = false;
			fishRad.checked = octopusRad.checked = snakeRad.checked = false;
			
			var type:int = Math.random() * 3;
			if (type < 1)
			{
				fish.visible = true;
				fishRad.checked = true;
			}
			else if (type < 2)
			{
				octopus.visible = true;
				octopusRad.checked = true;
			}
			else if (type < 3)
			{
				snake.visible = true;
				snakeRad.checked = true;
			}
			
			hatCheck.checked = hat.visible = Math.random() < 0.5;
			wingsCheck.checked = wing.visible = Math.random() < 0.5;
			laserCheck.checked = laser.visible = Math.random() < 0.5;
			friendCheck.checked = friend.visible = Math.random() < 0.5;
			
			nameInput.text = FP.choose("Pikachu", "Link", "Slim Shady", "Abel Toy", "Me", "Meat Pet", "Daddy",
			"Leonardo DiCaprio", "Mr. Burns", "Peter", "TYPE YOUR NAME", "Derp");
		}
	}
}